<?php

defined( 'ABSPATH' ) or die( 'Access denied' );

if( ! class_exists( 'A_W_F_preset_frontend' ) ) {
  class A_W_F_preset_frontend extends A_W_F_preset {

  /*  Parent properties:
        public $id;
        public $name;
        public $title;
        public $button_on;
        public $ajax_on;
    */

    public $caller_id;
    public $is_url_query;
    public $filters = array();
    public $counts = array();

    public function __construct( $preset_id, $caller_id = null ) {

      parent::__construct( $preset_id );

      $this->caller_id = $caller_id;

      foreach( A_W_F::$presets[$this->id]['filters'] as $filter_id => $filter_position ) {
        $filter = new A_W_F::$front->filters_manager( $this, $filter_id );
        $this->filters[$filter->name] = $filter;
      }
    }

    public function get_html() {

      $wrapper_classes[] = 'awf-preset-wrapper';

      if( 'no' === $this->ajax_on && 'no' === $this->button_on ) {
        $this->is_url_query = true;
        $wrapper_classes[] = 'awf-url';
      }

      if( 'yes' === $this->ajax_on ) {
        $wrapper_classes[] = 'awf-ajax';
        switch( $this->button_on ) {
            case 'no': $wrapper_classes[] = 'awf-instant'; break;
            case 'yes': $wrapper_classes[] = 'awf-button'; break;
        }
      }

      $html = '<div id="' . $this->caller_id . '-preset-' . $this->id . '-wrapper" class="' . implode( ' ', $wrapper_classes ) . '">';
      $html .= '<div class="awf-preset-title">' . esc_html( $this->title ) . '</div>';

      if( 'yes' === $this->show_title_badges ) {
        $html .= '<div class="awf-active-badges-container"></div>';
      }

      if( 'top' === $this->reset_btn || 'both' === $this->reset_btn ) {
        $html .= $this->reset_btn_html();
      }

      $html .= '<form class="awf-filters-form" action="' . esc_url( A_W_F::$front->shop_url ) . '" method="post">';

      foreach( $this->filters as $filter ) {
        $html .= $filter->get_html();
      }

      if( 'bottom' === $this->reset_btn || 'both' === $this->reset_btn ) {
        $html .= $this->reset_btn_html();
      }

      if( 'yes' === $this->button_on ) {
        if( 'yes' === $this->ajax_on ) {
          $html .= '<div class="awf-btn-container"><button type="button" class="awf-apply-filter-btn">' . esc_html_x( 'Filter', 'Filter button label', 'annasta-filters' ) . '</button></div>';
          
        } else {
          if( ! empty( A_W_F::$front->is_sc_page ) ) {
            $html .= '<input type="hidden" name="awf_sc_page" value="' . A_W_F::$front->is_sc_page . '">';
            
          } elseif( ! empty( A_W_F::$front->shop_on_frontpage )
             && (
               ! empty( A_W_F::$front->is_frontpage )
               || is_search()
               || ( ! empty( A_W_F::$front->query->awf['s'] ) || ! empty( A_W_F::$front->query->awf['orderby'] ) )
             )
            ) {
            $html .= '<input type="hidden" name="awf_is_frontpage_shop" value="yes">';
          }
          
          $html .= '<div class="awf-btn-container"><button type="submit" name="awf_submit" value="1" class="awf-form-submit-btn">' . esc_html_x( 'Filter', 'Filter button label', 'annasta-filters' ) . '</button></div>';
        }
      }

      $html .= '</form>';
      $html .= '</div>';
      
      return $html;
    }

    private function reset_btn_html() {
      $html = '<div class="awf-reset-btn-container"><button type="button" title="' . esc_attr__( 'Clear all filters', 'annasta-filters' ) . '" class="awf-reset-btn">' . esc_html__( 'Clear all', 'annasta-filters' ) . '</button></div>';

      return $html;
    }

  }
}

?>